Unit ASK1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASK1R(var A1 :Array of Real; var B :Array of Real;
                var Y :Array of Real; var B3 :Array of Real;
                var L :Array of Integer; var N :Array of Integer;
                var C :Array of Real; var Q :Array of Integer;
                M :Integer; P :Integer);

implementation

procedure ASK1R(var A1 :Array of Real; var B :Array of Real;
                var Y :Array of Real; var B3 :Array of Real;
                var L :Array of Integer; var N :Array of Integer;
                var C :Array of Real; var Q :Array of Integer;
                M :Integer; P :Integer);
var
I,J,K,D,E,F,G,V,W,Z,BA,BB,BD,BE,BF,BG,BH,BI,BJ,BK,BL,BN,BT,CC,
   CK :Integer;
A,BQ,BR,BS,BW,BX,BY,CA,CD,CI,CL,CU,CX :Real;
const
ZERO :Real = 0.0;
label
_1,_115,_2,_3,_4,_5,_6,_7,_8,_1008,_9,_1009,_10,_11,_12,_1012,_13,
_1013,_14,_15,_16,_116,_17,_18,_109,_19,_20,_22,_23,_5023,_24,_25,_26,
_27,_117,_28,_29,_1029,_30,_31,_32,_33,_34,_1034,_35,_1035,_36,_37,
_38,_1038,_39,_1039,_40,_41,_42,_118,_43,_44,_45,_46,_47,_48,_49,_50,
_58,_581,_59,_56,_90,_92,_91,_51,_60,_601,_61,_63,_69,_64,_77,_771,
_78,_71,_74,_73,_72,_21,_67,_671,_68,_79,_80,_82,_84,_89,_99,_100,
_101,_103,_1031,_104,_105,_106,_110,_108,_112;
begin
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_1:
    B3[(I-1)+(J-1)*M+0*M*M] := A1[(I-1)+(J-1)*M+0*M*M];
   end;
 end;
if ( M > 1 )
 then goto _115;
B3[0+0*M+0*M*M] := 1.0/B3[0+0*M+0*M*M];
goto _116;
_115:
V := 1;
W := 1;
_2:
J := W;
BN := V;
BQ := ZERO;
for I:=V to M do
 begin
  CA := Abs(B3[(I-1)+(J-1)*M+0*M*M]);
  if ( BQ >= CA ) 
   then goto _3;
  BQ := CA;
  BN := I;
_3:
 end;
for J:=1 to M do
 begin
  CU := B3[(BN-1)+(J-1)*M+0*M*M];
  B3[(BN-1)+(J-1)*M+0*M*M] := B3[(V-1)+(J-1)*M+0*M*M];
  B3[(V-1)+(J-1)*M+0*M*M] := CU;
_4:
 end;
C[(V-1)+1*M+1*M*M] := B3[(V-1)+(W-1)*M+0*M*M];
Q[V-1] := BN;
J := W;
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := B3[(I-1)+(J-1)*M+0*M*M];
_5:
 end;
BR := 1.0/C[(V-1)+0*M+1*M*M];
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := -(C[(I-1)+0*M+1*M*M]*BR);
_6:
 end;
C[(V-1)+0*M+1*M*M] := BR;
BF := 0;
_7:
BF := BF+1;
if ( M < BF ) 
 then goto _10;
CD := B3[(V-1)+(BF-1)*M+0*M*M];
CC := V-1;
if ( CC < 1 ) 
 then goto _1008;
for BG:=1 to CC do
 begin
  B3[(BG-1)+(BF-1)*M+0*M*M] := B3[(BG-1)+(BF-1)*M+0*M*M]+C[(BG-1)+0*M+1*M*M]*CD;
_8:
 end;
_1008:
CC := V+1;
if ( M < CC ) 
 then goto _1009;
for BG:=CC to M do
 begin
  B3[(BG-1)+(BF-1)*M+0*M*M] := B3[(BG-1)+(BF-1)*M+0*M*M]+C[(BG-1)+0*M+1*M*M]*CD;
_9:
 end;
_1009:
goto _7;
_10:
for I:=1 to M do
 begin
  B3[(I-1)+(J-1)*M+0*M*M] := C[(I-1)+0*M+1*M*M];
_11:
 end;
BE := J+1;
if ( M < BE ) 
 then goto _1012;
for BF:=BE to M do
 begin
  B3[(V-1)+(BF-1)*M+0*M*M] := B3[(V-1)+(BF-1)*M+0*M*M]*B3[(V-1)+(W-1)*M+0*M*M];
_12:
 end;
_1012:
BE := J-1;
if ( BE < 1 ) 
 then goto _1013;
for BF:=1 to BE do
 begin
  B3[(V-1)+(BF-1)*M+0*M*M] := B3[(V-1)+(BF-1)*M+0*M*M]*B3[(V-1)+(W-1)*M+0*M*M];
_13:
 end;
_1013:
V := V+1;
W := W+1;
if ( V > M ) 
 then goto _14;
if ( W <= M ) 
 then goto _2;
_14:
I := 1;
_15:
BH := IntSign(1,1-M);
Z := M-BH;
_16:
Z := Z+BH;
J := Q[Z-1];
BS := B3[(I-1)+(J-1)*M+0*M*M];
B3[(I-1)+(J-1)*M+0*M*M] := B3[(I-1)+(Z-1)*M+0*M*M];
B3[(I-1)+(Z-1)*M+0*M*M] := BS;
if ( Z <> 1 ) 
 then goto _16;
I := I+1;
if ( I <= M ) 
 then goto _15;
_116:
for I:=1 to M do
 begin
_17:
  Y[(I-1)+0*M] := 0.0;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_18:
    Y[(I-1)+0*M] := Y[(I-1)+0*M]+B3[(I-1)+(J-1)*M+0*M*M]*B[(J-1)+0*M];
   end;
 end;
D  := 1;
_109:
D := D+1;
if ( D > P )
 then goto _112;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_19:
    C[(I-1)+(J-1)*M+2*M*M] := 0.0;
   end;
 end;
for K:=2 to D do
 begin
  for E:=1 to M do
   begin
    for J:=1 to M do
     begin
      for I:=1 to M do
       begin
_20:
        C[(I-1)+(E-1)*M+2*M*M] := C[(I-1)+(E-1)*M+2*M*M]+A1[(I-1)+(J-1)*M+(K-1)*M*M]*B3[(J-1)+(E-1)*M+(K-2)*M*M];
       end;
     end;
   end;
 end;
for J:=1 to M do
 begin
  E := L[J-1];
  Q[J-1] := E;
  for I:=1 to M do
   begin
_22:
    C[(I-1)+(J-1)*M+1*M*M] := C[(I-1)+(E-1)*M+2*M*M];
   end;
 end;
for I:=1 to M do
 begin
  E := L[I-1];
  if ( E = I ) 
   then goto _5023;
  L[I-1] := I;
  L[E-1] := E;
  for J:=1 to M do
   begin
    A := C[(E-1)+(J-1)*M+1*M*M];
    C[(E-1)+(J-1)*M+1*M*M] := C[(I-1)+(J-1)*M+1*M*M];
    C[(I-1)+(J-1)*M+1*M*M] := A;
_23:
   end;
_5023:
 end;
for I:=1 to M do
 begin
_24:
  L[I-1] := Q[I-1];
 end;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_25:
    C[(I-1)+(E-1)*M+0*M*M] := 0.0;
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_26:
      C[(I-1)+(E-1)*M+0*M*M] := C[(I-1)+(E-1)*M+0*M*M]+C[(I-1)+(J-1)*M+1*M*M]*C[(J-1)+(E-1)*M+2*M*M];
     end;
   end;
 end;
for J:=1 to M do
 begin
  C[(J-1)+(J-1)*M+0*M*M] := C[(J-1)+(J-1)*M+0*M*M]-1.0;
  for I:=1 to M do
   begin
_27:
    C[(I-1)+(J-1)*M+0*M*M] := -C[(I-1)+(J-1)*M+0*M*M];
   end;
 end;
if ( M > 1 )
 then goto _117;
C[0+0*M+0*M*M] := 1.0/C[0+0*M+0*M*M];
goto _118;
_117:
BA := 1;
BB := 1;
_28:
J := BB;
BT := BA;
BW := ZERO;
if ( M < BA ) 
 then goto _1029;
for I:=BA to M do
 begin
  CI := Abs(C[(I-1)+(J-1)*M+0*M*M]);
  if ( BW >= CI ) 
   then goto _29;
  BW := CI;
  BT := I;
_29:
 end;
_1029:
for J:=1 to M do
 begin
  CX := C[(BT-1)+(J-1)*M+0*M*M];
  C[(BT-1)+(J-1)*M+0*M*M] := C[(BA-1)+(J-1)*M+0*M*M];
  C[(BA-1)+(J-1)*M+0*M*M] := CX;
_30:
 end;
C[(BA-1)+1*M+1*M*M] := C[(BA-1)+(BB-1)*M+0*M*M];
Q[BA-1] := BT;
J := BB;
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := C[(I-1)+(J-1)*M+0*M*M];
_31:
 end;
BX := 1.0/C[(BA-1)+0*M+1*M*M];
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := -(C[(I-1)+0*M+1*M*M]*BX);
_32:
 end;
C[(BA-1)+0*M+1*M*M] := BX;
BJ := 0;
_33:
BJ := BJ+1;
if ( M < BJ ) 
 then goto _36;
CL := C[(BA-1)+(BJ-1)*M+0*M*M];
CK := BA-1;
if ( CK < 1 ) 
 then goto _1034;
for BK:=1 to CK do
 begin
  C[(BK-1)+(BJ-1)*M+0*M*M] := C[(BK-1)+(BJ-1)*M+0*M*M]+C[(BK-1)+0*M+1*M*M]*CL;
_34:
 end;
_1034:
CK := BA+1;
if ( M < CK ) 
 then goto _1035;
for BK:=CK to M do
 begin
  C[(BK-1)+(BJ-1)*M+0*M*M] := C[(BK-1)+(BJ-1)*M+0*M*M]+C[(BK-1)+0*M+1*M*M]*CL;
_35:
 end;
_1035:
goto _33;
_36:
for I:=1 to M do
 begin
  C[(I-1)+(J-1)*M+0*M*M] := C[(I-1)+0*M+1*M*M];
_37:
 end;
BI := J+1;
if ( M < BI ) 
 then goto _1038;
for BJ:=BI to M do
 begin
  C[(BA-1)+(BJ-1)*M+0*M*M] := C[(BA-1)+(BJ-1)*M+0*M*M]*C[(BA-1)+(BB-1)*M+0*M*M];
_38:
 end;
_1038:
BI := J-1;
if ( BI < 1 ) 
 then goto _1039;
for BJ:=1 to BI do
 begin
  C[(BA-1)+(BJ-1)*M+0*M*M] := C[(BA-1)+(BJ-1)*M+0*M*M]*C[(BA-1)+(BB-1)*M+0*M*M];
_39:
 end;
_1039:
BA := BA+1;
BB := BB+1;
if ( BA > M ) 
 then goto _40;
if ( BB <= M ) 
 then goto _28;
_40:
I := 1;
_41:
BL := IntSign(1,1-M);
BD := M-BL;
_42:
BD := BD+BL;
J := Q[BD-1];
BY := C[(I-1)+(J-1)*M+0*M*M];
C[(I-1)+(J-1)*M+0*M*M] := C[(I-1)+(BD-1)*M+0*M*M];
C[(I-1)+(BD-1)*M+0*M*M] := BY;
if ( BD <> 1 ) 
 then goto _42;
I := I+1;
if ( I <= M ) 
 then goto _41;
_118:
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_43:
    C[(I-1)+(E-1)*M+1*M*M] := 0.0;
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_44:
      C[(I-1)+(E-1)*M+1*M*M] := C[(I-1)+(E-1)*M+1*M*M]+C[(I-1)+(J-1)*M+2*M*M]*C[(J-1)+(E-1)*M+0*M*M];
     end;
   end;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    C[(I-1)+(J-1)*M+1*M*M] := -C[(I-1)+(J-1)*M+1*M*M];
_45:
   end;
_46:
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_47:
    C[(I-1)+(J-1)*M+2*M*M] := 0.0;
   end;
 end;
F := D;
G := F-1;
K := 0;
V := 56;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_48:
    B3[(I-1)+(E-1)*M+(F-1)*M*M] := 0.0;
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_49:
      B3[(I-1)+(E-1)*M+(F-1)*M*M] := B3[(I-1)+(E-1)*M+(F-1)*M*M]+B3[(I-1)+(J-1)*M+(G-1)*M*M]*C[(J-1)+(E-1)*M+0*M*M];
     end;
   end;
 end;
for I:=1 to M do
 begin
_50:
  Q[I-1] := L[I-1];
 end;
for J:=1 to M do
 begin
  E := L[J-1];
  if ( E = J ) 
   then goto _581;
  L[J-1] := J;
  L[E-1] := E;
  for I:=1 to M do
   begin
    A := C[(E-1)+(I-1)*M+1*M*M];
    C[(E-1)+(I-1)*M+1*M*M] := C[(J-1)+(I-1)*M+1*M*M];
    C[(J-1)+(I-1)*M+1*M*M] := A;
_58:
   end;
_581:
 end;
for J:=1 to M do
 begin
_59:
  L[J-1] := Q[J-1];
 end;
_56:
K := K+1;
F := D-K;
G := F-1;
if ( K >= G ) 
 then goto _73;
_90:
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    Y[(J-1)+(P-1)*M] := 0.0;
    for E:=1 to M do
     begin
_92:
      Y[(J-1)+(P-1)*M] := Y[(J-1)+(P-1)*M]+C[(I-1)+(E-1)*M+2*M*M]*C[(E-1)+(J-1)*M+0*M*M];
     end;
   end;
  for J:=1 to M do
   begin
_91:
    C[(I-1)+(J-1)*M+2*M*M] := Y[(J-1)+(P-1)*M];
   end;
 end;
for J:=1 to M do
 begin
_51:
  Q[J-1] := N[J-1];
 end;
for I:=1 to M do
 begin
  E := N[I-1];
  if ( E = I ) 
   then goto _601;
  N[I-1] := I;
  N[E-1] := E;
  for J:=1 to M do
   begin
    A := B3[(E-1)+(J-1)*M+(F-1)*M*M];
    B3[(E-1)+(J-1)*M+(F-1)*M*M] := B3[(I-1)+(J-1)*M+(F-1)*M*M];
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := A;
_60:
   end;
_601:
 end;
for I:=1 to M do
 begin
_61:
  N[I-1] := Q[I-1];
 end;
for E:=1 to M do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_63:
      C[(I-1)+(E-1)*M+2*M*M] := C[(I-1)+(E-1)*M+2*M*M]+B3[(I-1)+(J-1)*M+(F-1)*M*M]*C[(J-1)+(E-1)*M+1*M*M];
     end;
   end;
 end;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_69:
    B3[(I-1)+(E-1)*M+(F-1)*M*M] := 0.0;
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_64:
      B3[(I-1)+(E-1)*M+(F-1)*M*M] := B3[(I-1)+(E-1)*M+(F-1)*M*M]+B3[(I-1)+(J-1)*M+(K-1)*M*M]*C[(J-1)+(E-1)*M+1*M*M];
     end;
   end;
 end;
for I:=1 to M do
 begin
  E := N[I-1];
  if ( E = I ) 
   then goto _771;
  N[I-1] := I;
  N[E-1] := E;
  for J:=1 to M do
   begin
    A := B3[(E-1)+(J-1)*M+(F-1)*M*M];
    B3[(E-1)+(J-1)*M+(F-1)*M*M] := B3[(I-1)+(J-1)*M+(F-1)*M*M];
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := A;
_77:
   end;
_771:
 end;
for I:=1 to M do
 begin
_78:
  N[I-1] := Q[I-1];
 end;
for E:=1 to M do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_71:
      B3[(I-1)+(E-1)*M+(F-1)*M*M] := B3[(I-1)+(E-1)*M+(F-1)*M*M]+B3[(I-1)+(J-1)*M+(G-1)*M*M]*C[(J-1)+(E-1)*M+0*M*M];
     end;
   end;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    A := B3[(I-1)+(J-1)*M+(K-1)*M*M];
    B3[(I-1)+(J-1)*M+(K-1)*M*M] := C[(I-1)+(J-1)*M+2*M*M];
_74:
    C[(I-1)+(J-1)*M+2*M*M] := A;
   end;
 end;
if ( V=56 ) then goto _56 else
if ( V=99 ) then goto _99;
_73:
if ( K = F )
 then goto _72;
V := 99;
goto _90;
_72:
for I:=1 to M do
 begin
_21:
  Q[I-1] := N[I-1];
 end;
for I:=1 to M do
 begin
  E := N[I-1];
  if ( E = I ) 
   then goto _671;
  N[I-1] := I;
  N[E-1] := E;
  for J:=1 to M do
   begin
    A := B3[(E-1)+(J-1)*M+(F-1)*M*M];
    B3[(E-1)+(J-1)*M+(F-1)*M*M] := B3[(I-1)+(J-1)*M+(F-1)*M*M];
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := A;
_67:
   end;
_671:
 end;
for I:=1 to M do
 begin
_68:
  N[I-1] := Q[I-1];
 end;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_79:
    Y[(I-1)+(P-1)*M] := 0.0;
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_80:
      Y[(I-1)+(P-1)*M] := Y[(I-1)+(P-1)*M]+B3[(I-1)+(J-1)*M+(F-1)*M*M]*C[(J-1)+(E-1)*M+1*M*M];
     end;
   end;
  for I:=1 to M do
   begin
_82:
    C[(I-1)+(E-1)*M+1*M*M] := Y[(I-1)+(P-1)*M];
   end;
 end;
for E:=1 to M do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_84:
      C[(I-1)+(E-1)*M+1*M*M] := C[(I-1)+(E-1)*M+1*M*M]+C[(I-1)+(J-1)*M+2*M*M]*C[(J-1)+(E-1)*M+0*M*M];
     end;
   end;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_89:
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := C[(I-1)+(J-1)*M+1*M*M];
   end;
 end;
_99:
for I:=1 to M do
 begin
_100:
  C[(I-1)+0*M+0*M*M] := B[(I-1)+(D-1)*M];
 end;
F := D;
for K:=2 to D do
 begin
  F := F-1;
  for J:=1 to M do
   begin
    E := N[J-1];
    Q[J-1] := L[J-1];
    for I:=1 to M do
     begin
_101:
      C[(I-1)+(J-1)*M+1*M*M] := A1[(I-1)+(E-1)*M+(K-1)*M*M];
     end;
   end;
  for I:=1 to M do
   begin
    E := L[I-1];
    if ( E = I ) 
     then goto _1031;
    L[I-1] := I;
    L[E-1] := E;
    for J:=1 to M do
     begin
      A := C[(E-1)+(J-1)*M+1*M*M];
      C[(E-1)+(J-1)*M+1*M*M] := C[(I-1)+(J-1)*M+1*M*M];
      C[(I-1)+(J-1)*M+1*M*M] := A;
_103:
     end;
_1031:
   end;
  for I:=1 to M do
   begin
_104:
    L[I-1] := Q[I-1];
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_105:
      C[(I-1)+0*M+0*M*M] := C[(I-1)+0*M+0*M*M]-C[(I-1)+(J-1)*M+1*M*M]*Y[(J-1)+(F-1)*M];
     end;
   end;
_106:
 end;
for I:=1 to M do
 begin
_110:
  Y[(I-1)+(D-1)*M] := 0.0;
 end;
for K:=1 to D do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_108:
      Y[(I-1)+(K-1)*M] := Y[(I-1)+(K-1)*M]+B3[(I-1)+(J-1)*M+(K-1)*M*M]*C[(J-1)+0*M+0*M*M];
     end;
   end;
 end;
goto _109;
_112:
end;

end.
